/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.stimmeingabe.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.stimmeingabe.entity.ErgebnisGueltigerEingang;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class ErgebnisGueltigerEingangExtendedDAO extends AbstractErgebnisGueltigerEingangDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: CountGueltigeEingaengeByErgebnisNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT COUNT(o) FROM ErgebnisGueltigerEingang o WHERE o.ergebnis = ?1<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByCountGueltigeEingaengeByErgebnis( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("ErgebnisGueltigerEingang.findByCountGueltigeEingaengeByErgebnis" ,  ergebnis  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByCountGueltigeEingaengeByErgebnis(): Miss");
        }

        cache.put(key, super.findByCountGueltigeEingaengeByErgebnis( ergebnis  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByCountGueltigeEingaengeByErgebnis(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByCountGueltigeEingaengeByErgebnis( ergebnis  );
}
/**
* Name: ErgebnisNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebnis = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<ErgebnisGueltigerEingang> findByErgebnis( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("ErgebnisGueltigerEingang.findByErgebnis" ,  ergebnis  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByErgebnis(): Miss");
        }

        cache.put(key, super.findByErgebnis( ergebnis  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByErgebnis(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<ErgebnisGueltigerEingang>) cache.lookup(key));
    }

    return super.findByErgebnis( ergebnis  );
}
/**
* Name: WahlAndErgebniseingangsartGebietnummerGebietsartnameNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM ErgebnisGueltigerEingang o WHERE o.ergebnis.wahl =?1 AND o.ergebniseingang.ergebniseingangsart=?2 AND o.ergebniseingang.wahldurchfuehrungsgebiet.nummer = ?3 AND o.ergebniseingang.wahldurchfuehrungsgebiet.gebietsart.name = ?4<br>
* SQL: <br>
*/
@Override
public java.util.List<ErgebnisGueltigerEingang> findByWahlAndErgebniseingangsartGebietnummerGebietsartname( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsart,  @javax.annotation.Nonnull String gebietNummer,  @javax.annotation.Nonnull String gebietsartName) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("ErgebnisGueltigerEingang.findByWahlAndErgebniseingangsartGebietnummerGebietsartname" ,  wahl ,  ergebniseingangsart ,  gebietNummer ,  gebietsartName  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlAndErgebniseingangsartGebietnummerGebietsartname(): Miss");
        }

        cache.put(key, super.findByWahlAndErgebniseingangsartGebietnummerGebietsartname( wahl ,  ergebniseingangsart ,  gebietNummer ,  gebietsartName  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlAndErgebniseingangsartGebietnummerGebietsartname(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<ErgebnisGueltigerEingang>) cache.lookup(key));
    }

    return super.findByWahlAndErgebniseingangsartGebietnummerGebietsartname( wahl ,  ergebniseingangsart ,  gebietNummer ,  gebietsartName  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
